package minichatclient;

import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.net.*;
import java.util.*;

import javax.swing.*;

public class MiniChatClientDlg extends JFrame implements MessageListener {
    private Socket socket;
    private boolean connected = false;
    private ReceivingThread receivingThread;

    private static final int FSGLIST = 0;
    private static final int FSLOGIN = 1;
    private static final int FSLOGOUT = 2;
    private static final int FSULIST = 3;
    private static final int FSMESG = 4;
    private int fstate=FSMESG;

    JPanel contentPane;
    JButton btnConnect = new JButton();
    JButton jButton1 = new JButton();
    JButton btnLogin = new JButton();
    JButton btnUsers = new JButton();
    JButton btnGroups = new JButton();
    JButton btnLogout = new JButton();
    JButton btnSend = new JButton();
    JLabel jLabel1 = new JLabel();
    JScrollPane jspGroups = new JScrollPane();
    JList jlbGroups = new JList();
    JLabel jLabel2 = new JLabel();
    JScrollPane jspUsers = new JScrollPane();
    JList jlbUsers = new JList();
    JLabel jLabel3 = new JLabel();
    JScrollPane jspContent = new JScrollPane();
    javax.swing.JList jlbContent = new javax.swing.JList();
    JLabel jLabel4 = new JLabel();
    JTextField jtfMessage = new JTextField();
    public MiniChatClientDlg() {
        try {
            setDefaultCloseOperation(EXIT_ON_CLOSE);
            jbInit();
        } catch (Exception exception) {
            exception.printStackTrace();
        }
    }

    /**
     * Component initialization.
     *
     * @throws java.lang.Exception
     */
    private void jbInit() throws Exception {
        this.jlbContent.setModel(new DefaultListModel());
        this.jlbUsers.setModel(new DefaultListModel());
    	contentPane = (JPanel) getContentPane();
        contentPane.setLayout(null);
        setSize(new Dimension(500, 430));
        setTitle("Chat Client");
        btnConnect.setBounds(new Rectangle(3, 2, 77, 24));
        btnConnect.setText("Connect");
        btnConnect.addActionListener(new
                                     MiniChatClientDlg_btnConnect_actionAdapter(this));
        jButton1.setBounds(new Rectangle(3, 2, 77, 24));
        jButton1.setText("Connect");
        btnLogin.setBounds(new Rectangle(165, 2, 77, 24));
        btnLogin.setText("Login");
        btnLogin.addActionListener(new MiniChatClientDlg_btnLogin_actionAdapter(this));
        btnUsers.setBounds(new Rectangle(247, 2, 77, 24));
        btnUsers.setText("Users");
        btnGroups.setBounds(new Rectangle(84, 2, 77, 24));
        btnGroups.setText("Groups");
        btnGroups.addActionListener(new
                                    MiniChatClientDlg_btnGroups_actionAdapter(this));
        btnLogout.setBounds(new Rectangle(409, 2, 77, 24));
        btnLogout.setText("Logout");
        btnLogout.addActionListener(new
                                    MiniChatClientDlg_btnLogout_actionAdapter(this));
        btnSend.setBounds(new Rectangle(328, 2, 77, 24));
        btnSend.setText("Send");
        jLabel1.setText("Noi dung tan gau:");
        jLabel1.setBounds(new Rectangle(206, 127, 173, 30));
        jspGroups.setBounds(new Rectangle(11, 75, 141, 127));
        jLabel2.setText("Danh sach nhom");
        jLabel2.setBounds(new Rectangle(12, 37, 173, 30));
        jspUsers.setBounds(new Rectangle(9, 241, 142, 127));
        jLabel3.setText("Noi dung can goi:");
        jLabel3.setBounds(new Rectangle(207, 37, 173, 30));
        jspContent.setBounds(new Rectangle(208, 159, 273, 213));
        jLabel4.setText("Danh sach user");
        jLabel4.setBounds(new Rectangle(10, 210, 173, 30));
        jtfMessage.setText("");
        jtfMessage.setBounds(new Rectangle(208, 72, 271, 26));
        jtfMessage.addKeyListener(new MiniChatClientDlg_jtfMessage_keyAdapter(this));
        btnUsers.addActionListener(new MiniChatClientDlg_btnUsers_actionAdapter(this));
        btnSend.addActionListener(new MiniChatClientDlg_btnSend_actionAdapter(this));
        btnConnect.addActionListener(new
                                     MiniChatClientDlg_btnConnect_actionAdapter(this));
        contentPane.add(btnConnect);
        contentPane.add(btnLogin);
        contentPane.add(btnGroups);
        contentPane.add(btnUsers);
        contentPane.add(btnSend);
        contentPane.add(btnLogout);
        contentPane.add(jspGroups);
        contentPane.add(jLabel2);
        contentPane.add(jspUsers);
        contentPane.add(jLabel1);
        contentPane.add(jspContent);
        contentPane.add(jLabel4);
        contentPane.add(jLabel3);
        contentPane.add(jtfMessage);
        jspContent.getViewport().add(jlbContent);
        jspUsers.getViewport().add(jlbUsers);
        jspGroups.getViewport().add(jlbGroups);
    }

    public void btnConnect_actionPerformed(ActionEvent e) {
        ConnectDlg dlg = new ConnectDlg(new javax.swing.JFrame(),
                                        "Nhap thong tin ve server ", true);
        dlg.show();
        if (dlg.fOK) { // thuc hien connect
            try {
                socket = new Socket(InetAddress.getByName(dlg.jtfIpaddr.getText())
                                    , 2560);
                // create Thread for receiving incoming messages
                receivingThread = new ReceivingThread(this, socket);
                receivingThread.start();
            }
            // handle exception connecting to server
            catch (IOException ioException) {
                ioException.printStackTrace();
                // update connected flag
                connected = true;
            }
        }
    }

    public void btnGroups_actionPerformed(ActionEvent e) {
        String mesg = "GLIST ";
        SendMessage(socket,mesg);
        fstate = FSGLIST;
    }

    public void btnUsers_actionPerformed(ActionEvent e) {
        String mesg = "ULIST ";
        SendMessage(socket,mesg);
        fstate = FSULIST;

    }

    public void btnSend_actionPerformed(ActionEvent e) {
        SendToGroup();
    }

    public void btnLogout_actionPerformed(ActionEvent e) {
        String mesg;
        mesg = "LOGOU ";
        SendMessage(socket,mesg);
        fstate = FSLOGOUT;
    }

    public void btnLogin_actionPerformed(ActionEvent e) {
        LoginDlg dlg;
        if (jlbGroups.getSelectedValue().toString() == null)
            dlg = new LoginDlg(new javax.swing.JFrame(), "Nhap thong tin login", true,
                               "");
        else
          dlg = new LoginDlg(new javax.swing.JFrame(), "Nhap thong tin login", true,
                               jlbGroups.getSelectedValue().toString());
        dlg.show();
        if (dlg.fOK) { // thuc hien connect
            String request;
            request = "LOGIN " + dlg.jtfGroupname.getText() + "," +
                      dlg.jtfUsername.getText();
            SendMessage(socket,request);
            fstate = FSLOGIN;
        }
    }
    public void SendMessage(Socket sock, String mesg) {
            // send message and flush PrintWriter
            try {
                PrintWriter writer = new PrintWriter( sock.getOutputStream() );
                writer.println(mesg);
                writer.flush();
            }
            // handle exception sending message
            catch ( IOException ioException ) {
                ioException.printStackTrace();
            }
    }

    public void jtfMessage_keyPressed(KeyEvent e) {
        if (e.getKeyCode()==10) SendToGroup();
    }
    private void SendToGroup() {
        String mesg = jtfMessage.getText();
        if (mesg != "")
            SendMessage(socket,"SEND "+mesg);
        fstate = FSMESG;
    }
    public void messageReceived( Socket sock, String mesg){
        int status;
        System.out.println("Received- " + mesg);
        if (mesg.compareTo("CLOSE ")==0) return;
        switch (fstate) {
        case FSLOGIN :
            Do_login(mesg);
            break;
        case FSLOGOUT:
            Do_logout(mesg);
            break;
        case FSMESG :
            Do_receive(mesg);
            break;
        case FSGLIST:
            Do_glist(mesg);
            break;
        case FSULIST:
            Do_ulist(mesg);
        }
        fstate = FSMESG;
    }
    private void Do_login(String mesg) {
    }
    private void Do_logout(String mesg) {
        if (mesg.charAt(0) == '0')return;
        DefaultListModel lmUsers = (DefaultListModel) jlbUsers.getModel();
        lmUsers.clear();
        DefaultListModel lmContent = (DefaultListModel) (jlbContent.getModel());
        lmContent.clear();
        //jlbContent.
    }
    private void Do_glist(String mesg) {
        int i;
        //DefaultListModel lmGroups = (DefaultListModel) jlbGroups.getModel();
        DefaultListModel lmGroups = new DefaultListModel();
        //lmGroups.clear();
        if (mesg.charAt(0) == '0')return;
        mesg = mesg.substring(2);
        System.out.println(mesg);
        // tokenize message to retrieve user name and message body
        StringTokenizer tokenizer = new StringTokenizer(mesg, ",");
        int size = tokenizer.countTokens();
        for (i = 0; i < size; i++)
            lmGroups.addElement( tokenizer.nextToken());
        jlbGroups.setModel(lmGroups);
    }
    private void Do_ulist(String mesg) {
        String gname;
        int i;
        DefaultListModel lmUsers = (DefaultListModel) jlbUsers.getModel();
        lmUsers.clear();
        if (mesg.charAt(0) == '0')return;
        if (mesg.length() < 3)return;
        mesg = mesg.substring(2);
        // tokenize message to retrieve user name and message body
        StringTokenizer tokenizer = new StringTokenizer(mesg, ",");
        int size = tokenizer.countTokens();
        for (i = 0; i < size; i++)
            lmUsers.addElement(tokenizer.nextToken());
    }
    private void Do_receive(String mesg) {
        ListModel lm = jlbContent.getModel();
        //System.out.println(lm.getClass().getName());
    	DefaultListModel lmContent = (DefaultListModel)lm;
        // append new message
        //DefaultListModel lmContent = new DefaultListModel();
    	lmContent.addElement(mesg);
    	jlbContent.setModel(lmContent);
    }
}


class MiniChatClientDlg_jtfMessage_keyAdapter extends KeyAdapter {
    private MiniChatClientDlg adaptee;
    MiniChatClientDlg_jtfMessage_keyAdapter(MiniChatClientDlg adaptee) {
        this.adaptee = adaptee;
    }

    public void keyPressed(KeyEvent e) {
        adaptee.jtfMessage_keyPressed(e);
    }
}


class MiniChatClientDlg_btnLogin_actionAdapter implements ActionListener {
    private MiniChatClientDlg adaptee;
    MiniChatClientDlg_btnLogin_actionAdapter(MiniChatClientDlg adaptee) {
        this.adaptee = adaptee;
    }

    public void actionPerformed(ActionEvent e) {
        adaptee.btnLogin_actionPerformed(e);
    }
}


class MiniChatClientDlg_btnLogout_actionAdapter implements ActionListener {
    private MiniChatClientDlg adaptee;
    MiniChatClientDlg_btnLogout_actionAdapter(MiniChatClientDlg adaptee) {
        this.adaptee = adaptee;
    }

    public void actionPerformed(ActionEvent e) {
        adaptee.btnLogout_actionPerformed(e);
    }
}


class MiniChatClientDlg_btnSend_actionAdapter implements ActionListener {
    private MiniChatClientDlg adaptee;
    MiniChatClientDlg_btnSend_actionAdapter(MiniChatClientDlg adaptee) {
        this.adaptee = adaptee;
    }

    public void actionPerformed(ActionEvent e) {
        adaptee.btnSend_actionPerformed(e);
    }
}


class MiniChatClientDlg_btnUsers_actionAdapter implements ActionListener {
    private MiniChatClientDlg adaptee;
    MiniChatClientDlg_btnUsers_actionAdapter(MiniChatClientDlg adaptee) {
        this.adaptee = adaptee;
    }

    public void actionPerformed(ActionEvent e) {
        adaptee.btnUsers_actionPerformed(e);
    }
}


class MiniChatClientDlg_btnGroups_actionAdapter implements ActionListener {
    private MiniChatClientDlg adaptee;
    MiniChatClientDlg_btnGroups_actionAdapter(MiniChatClientDlg adaptee) {
        this.adaptee = adaptee;
    }

    public void actionPerformed(ActionEvent e) {
        adaptee.btnGroups_actionPerformed(e);
    }
}


class MiniChatClientDlg_btnConnect_actionAdapter implements ActionListener {
    private MiniChatClientDlg adaptee;
    MiniChatClientDlg_btnConnect_actionAdapter(MiniChatClientDlg adaptee) {
        this.adaptee = adaptee;
    }

    public void actionPerformed(ActionEvent e) {

        adaptee.btnConnect_actionPerformed(e);
    }
}
