package minichatserver;

import com.borland.jbcl.layout.XYLayout;
import com.borland.jbcl.layout.*;
import java.awt.*;
import java.util.*;
import java.net.*;
import java.io.*;
import java.sql.*;
import javax.swing.*;
import java.awt.event.MouseEvent;
import java.awt.event.MouseAdapter;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;


public class MiniChatServerDlg extends JFrame implements MessageListener {
    int m_groupcnt; // số nhóm
    T_UserRec m_sock_no_user=null; // danh sách các user chưa login
    T_GroupList m_grouplist[] = new T_GroupList[10]; // danh sách nhóm
    String uname; // tên user
    ServerSocket serverSocket;
    final int SERVER_PORT = 2560; // port cua server

    JPanel contentPane;
    XYLayout xYLayout1 = new XYLayout();
    JLabel jLabel1 = new JLabel();
    JScrollPane jspGroupname = new JScrollPane();
    JList jlGroups = new JList();
    JScrollPane jScrollPane1 = new JScrollPane();
    JList jlUsers = new JList();
    JLabel jLabel2 = new JLabel();
    JLabel jLabel3 = new JLabel();
    JScrollPane jScrollPane2 = new JScrollPane();
    JList jlLog = new JList();
    JButton btnExit = new JButton();

    public MiniChatServerDlg() {
        try {
            jbInit();
        } catch (Exception ex) {
            ex.printStackTrace();
        }
        try {
            setDefaultCloseOperation(EXIT_ON_CLOSE);
            jbInit();
        } catch (Exception exception) {
            exception.printStackTrace();
        }
        // tạo các model chứa nội dung của các listbox
        DefaultListModel model = new DefaultListModel();
        jlGroups.setModel((ListModel) model);
        model = new DefaultListModel();
        jlUsers.setModel((ListModel) model);
        model = new DefaultListModel();
        jlLog.setModel((ListModel) model);
        // truy xuất danh sách nhóm từ database và hiển thị lên listbox Groups
        ReadDisplayGroups();
        try {
            serverSocket = new ServerSocket(SERVER_PORT, 100);
            DefaultListModel lmContent = (DefaultListModel) jlLog.getModel();
            lmContent.addElement("Server listening on port " + SERVER_PORT + " ...");
            // tạo thread con ₫ể ch? accept
            new ServerAcceptThread(this, serverSocket).start();
        } // end try
        // handle exception creating server and connecting clients
        catch (IOException ioException) {
            ioException.printStackTrace();
        }
    }

    /**
     * Component initialization.
     *
     * @throws java.lang.Exception
     */
    private void jbInit() throws Exception {
        jlGroups.addMouseListener(new MiniChatServerDlg_jlGroups_mouseAdapter(this));
        contentPane = (JPanel) getContentPane();
        contentPane.setLayout(xYLayout1);
        setSize(new Dimension(450, 350));
        setTitle("Chat Server");
        contentPane.setPreferredSize(new Dimension(500, 400));
        contentPane.setToolTipText("");
        jLabel1.setText("Danh sach cac nhom:");
        jLabel2.setText("Cac user trong nhom:");
        jLabel3.setText("Thong tin log:");
        btnExit.setText("Exit");
        btnExit.addActionListener(new MiniChatServerDlg_btnExit_actionAdapter(this));
        contentPane.add(jLabel1, new XYConstraints(11, 17, 122, 31));
        contentPane.add(jspGroupname, new XYConstraints(10, 43, 120, 101));
        contentPane.add(jScrollPane1, new XYConstraints(11, 184, 118, 102));
        contentPane.add(jLabel2, new XYConstraints(12, 161, -1, -1));
        contentPane.add(jLabel3, new XYConstraints(157, 26, -1, -1));
        jScrollPane1.getViewport().add(jlUsers);
        jspGroupname.getViewport().add(jlGroups);
        contentPane.add(jScrollPane2, new XYConstraints(158, 43, 233, 224));
        contentPane.add(btnExit, new XYConstraints(314, 272, 76, 25));
        jScrollPane2.getViewport().add(jlLog);
    }

    public void jlGroups_mouseClicked(MouseEvent e) {
        String gname = jlGroups.getSelectedValue().toString();
        int i, j;
        if (gname == null)return;
        for (i = 0; i < m_groupcnt; i++)
            if (gname.compareTo(m_grouplist[i].name) == 0)break;
        if (i >= m_groupcnt)return;
        T_UserRec ulist = m_grouplist[i].userlist;
        DefaultListModel lmUsers = (DefaultListModel) jlUsers.getModel();
        lmUsers.clear();
        while (ulist != null) {
            lmUsers.addElement(ulist.name);
            ulist = ulist.next;
        }
    }
    private void ReadDisplayGroups(){
        String conStr = "jdbc:odbc:Group";
        Connection con;
        String newSQL = "Select * from GroupList";
        DefaultListModel lmGroups = (DefaultListModel) jlGroups.getModel();
        try {
            Class.forName("sun.jdbc.odbc.JdbcOdbcDriver");
            //1. Tao connection mieu ta database can truy xuat
            con = DriverManager.getConnection(conStr, "", "");
            //2. Tao 1 doi tuong Statement lien ket den connection
            java.sql.Statement stmt = con.createStatement();
            //4. Tao doi tuong recordset chua ket qua cua lenh SQL
            ResultSet rs = stmt.executeQuery(newSQL);
            //5. Duyet recordset de xu ly cac record cua no
            int i = 0;
            lmGroups.clear();
            if (rs != null)while (rs.next()) {
                m_grouplist[i] = new T_GroupList();
                m_grouplist[i].name = rs.getString("groupname");
                lmGroups.addElement(m_grouplist[i].name);
                i++;
            }
            m_groupcnt = i;
            //6. Dong cac dong tuong da tao ra
            rs.close();
            stmt.close();
            con.close();
        } catch (Exception e) {
            System.out.println("Error : " + e);
        }
    }
    // hàm xử lý request ₫ến từ socket sock
    public void messageReceived( Socket sock, String mesg ) {
        int status;
        String opcode = mesg.substring(0, 5);
        if (opcode.compareTo("LOGIN") == 0) { // login
            Do_login(sock, mesg);
        } else if (opcode.compareTo("LOGOU") == 0) { // logout
            Do_logout(sock);
        } else if (opcode.compareTo("GLIST") == 0) { // group list
            Do_glist(sock);
        } else if (opcode.compareTo("ULIST") == 0) { // user list
            Do_ulist(sock);
        } else if (opcode.compareTo("CLOSE") == 0) { // user list
            Do_CloseSock(sock);
        } else { // broadcast message
            Do_MulticastMesg(sock, mesg.substring(5));
        }
    }
    private void Do_glist(Socket sock) {
        String mesg;
        int i;
        mesg = "1 " + m_grouplist[0].name;
        for (i = 1; i < m_groupcnt; i++) mesg = mesg + "," +
                                                m_grouplist[i].name;
        SendMessage(sock, mesg);
        System.out.println(mesg);
    }

    private int Findgroup(Socket sock) {
        int i;
        T_UserRec pu;
        for (i = 0; i < m_groupcnt; i++) {
            pu = m_grouplist[i].userlist;
            while (pu != null) {
                if (pu.sock == sock) {
                    uname = pu.name;
                    return i;
                }
                pu = pu.next;
            }
        }
        return -1;
    }
    private void Do_ulist(Socket sock) {
        String mesg;
        int i = Findgroup(sock);
        if (i < 0 || m_grouplist[i].userlist == null) {
            mesg = "0 ";
        } else {
            T_UserRec pu = m_grouplist[i].userlist;
            mesg = "1 ";
            while (pu != null) {
                mesg = mesg + pu.name;
                pu = pu.next;
                if (pu != null)
                    mesg = mesg + ",";
            }
        }
        SendMessage(sock, mesg);
    }
    private void Do_MulticastMesg(Socket sock, String mesg) {
        int i = Findgroup(sock);
        if (i < 0)return;
        mesg = uname + ":" + mesg;
        T_UserRec pu = m_grouplist[i].userlist;
        while (pu != null) {
            SendMessage(pu.sock, mesg);
            pu = pu.next;
        }
    }

    // Dong cau noi tuong ung
    private void Do_CloseSock(Socket sock) {
        int i = Findgroup(sock);
        T_UserRec pu, pup = null;
        if (i >= 0) {
            pu = m_grouplist[i].userlist;
            while (pu != null && pu.sock != sock) {
                pup = pu;
                pu = pu.next;
            }
            if (pu == m_grouplist[i].userlist)
                m_grouplist[i].userlist = pu.next;
            else pup.next = pu.next;
        } else {
            pu = m_sock_no_user;
            while (pu != null && pu.sock != sock) {
                pup = pu;
                pu = pu.next;
            }
            if (pu == m_sock_no_user)
                m_sock_no_user = pu.next;
            else pup.next = pu.next;
        }
        try {
            sock.close();
        }
        // handle exception connecting to server
        catch (IOException ioException) {
            ioException.printStackTrace();
        }
    }
    private void Do_login(Socket sock, String mesg) {
        T_UserRec pup, pu;
        String gname, uname;
        int i;
        mesg = mesg.substring(6);
        // tokenize message to retrieve user name and message body
        StringTokenizer tokenizer = new StringTokenizer(mesg, ",");
        // ignore messages that do not contain a user
        // name and message body
        if (tokenizer.countTokens() == 2) {
            gname = tokenizer.nextToken();
            uname = tokenizer.nextToken();
            // tim group tuong ung
            for (i = 0; i < m_groupcnt; i++)
                if (gname.compareTo(m_grouplist[i].name) == 0)break;
            System.out.println(gname + " " + uname + " " + i);
            if (i < m_groupcnt) {
            // tim sokcet trong danh sach chua co user
                pup = pu = m_sock_no_user;
                while (pu != null && pu.sock != sock) {
                    pup = pu;
                    pu = pu.next;
                }
                if (pu != null) {
                    if (pu == m_sock_no_user)
                        m_sock_no_user = pu.next;
                    else pup.next = pu.next;
                    pu.next = m_grouplist[i].userlist;
                    pu.name = uname;
                    m_grouplist[i].userlist = pu;
                    uname = "1 ";
                    SendMessage(sock, uname);
                    return;
                }
            }
        }
        errordisp:
                uname = "0 ";
        SendMessage(sock, uname);
    }
    private void Do_logout(Socket sock) {
        int i = Findgroup(sock);
        T_UserRec pu, pup = null;
        if (i >= 0) {
            pu = m_grouplist[i].userlist;
            while (pu != null && pu.sock != sock) {
                pup = pu;
                pu = pu.next;
            }
            if (pu == m_grouplist[i].userlist)
                m_grouplist[i].userlist = pu.next;
            else pup.next = pu.next;
            pu.next = m_sock_no_user;
            m_sock_no_user = pu;
            SendMessage(sock, "1 ");
        } else SendMessage(sock, "0 ");
    }
    public void SendMessage(Socket sock, String mesg) {
        // send message and flush PrintWriter
        try {
            PrintWriter writer = new PrintWriter(sock.getOutputStream());
            writer.println(mesg);
            writer.flush();
            System.out.println("Send- " + mesg);
        }
        // handle exception sending message
        catch (IOException ioException) {
            ioException.printStackTrace();
        }
    }

    public void btnExit_actionPerformed(ActionEvent e) {
        try {
            serverSocket.close();
        }
        catch (IOException ioException) {
            ioException.printStackTrace();
        }
        this.hide();
    }

}


class MiniChatServerDlg_btnExit_actionAdapter implements ActionListener {
    private MiniChatServerDlg adaptee;
    MiniChatServerDlg_btnExit_actionAdapter(MiniChatServerDlg adaptee) {
        this.adaptee = adaptee;
    }

    public void actionPerformed(ActionEvent e) {
        adaptee.btnExit_actionPerformed(e);
    }
}


class MiniChatServerDlg_jlGroups_mouseAdapter extends MouseAdapter {
    private MiniChatServerDlg adaptee;
    MiniChatServerDlg_jlGroups_mouseAdapter(MiniChatServerDlg adaptee) {
        this.adaptee = adaptee;
    }

    public void mouseClicked(MouseEvent e) {
        adaptee.jlGroups_mouseClicked(e);
    }
}
