package minichatserver;
import java.io.*;
import java.net.*;
public class ReceivingThread extends Thread {
    public ReceivingThread() {
        try {
            jbInit();
        } catch (Exception ex) {
            ex.printStackTrace();
        }
    }

    private BufferedReader input;
    private MessageListener messageListener;
    private boolean keepListening = true;
    Socket socket;

// ReceivingThread constructor
    public ReceivingThread(MessageListener listener, Socket clientSocket) {
        // invoke superclass constructor to name Thread
        super("ReceivingThread: " + clientSocket);
        // set listener to which new messages should be sent
        messageListener = listener;
        socket = clientSocket;
        // set timeout for reading from clientSocket and create
        // BufferedReader for reading incoming messages
        try {
            socket.setSoTimeout(5000);
            input = new BufferedReader(new InputStreamReader(socket.
                    getInputStream()));
        }
        // handle exception creating BufferedReader
        catch (IOException ioException) {
            ioException.printStackTrace();
        }
    } // end ReceivingThread constructor
    // listen for new messages and deliver them to MessageListener
    public void run()
    {
        String message;
        // listen for messages until stopped
        while ( keepListening ) {
                // read message from BufferedReader
                try {
                    message = input.readLine();
                }
                // handle exception if read times out
                catch ( InterruptedIOException interruptedIOException ) {
                        // continue to next iteration to keep listening
                        continue;
                }
                // handle exception reading message
                catch ( IOException ioException ) {
                    messageListener.messageReceived(
                            socket, // user name
                           "CLOSE "); // message body
                    break;
                }
                // ensure non-null message
                if ( message != null)
                    // send message to MessageListener
                    messageListener.messageReceived(socket, // user name
                                                    message); // message body
          } // end while
          // close BufferedReader (also closes Socket)
          try
          {
              input.close();
          }
          // handle exception closing BufferedReader
          catch ( IOException ioException ) {
              ioException.printStackTrace();
          }
      } // end method run
      // stop listening for incoming messages
      public void stopListening()
      {
          keepListening = false;
      }

    private void jbInit() throws Exception {
    }
}
