package minichatserver;
import java.util.*;
import java.net.*;
import java.io.*;
import javax.swing.*;

public class ServerAcceptThread extends Thread {
    ServerSocket serverSocket;
    MiniChatServerDlg serverChat;
    public ServerAcceptThread(MiniChatServerDlg server, ServerSocket sock) {
        serverSocket = sock;
        serverChat = server;
    }

    public void run() {
        T_UserRec puser;
        try {
                // listen for clients constantly
            while (true) {
                    // accept new client connection
                Socket clientSocket = serverSocket.accept();
                puser = new T_UserRec();
                puser.sock = clientSocket;
                puser.next = serverChat.m_sock_no_user;
                serverChat.m_sock_no_user = puser;
                // create new ReceivingThread for receiving messages from client
                new ReceivingThread(serverChat, clientSocket).start();
                // print connection information
                DefaultListModel lmContent =
                        (DefaultListModel) serverChat.jlLog.getModel();
                lmContent.addElement("Connection received from: " +
                                     clientSocket.getInetAddress());
                serverChat.SendMessage(clientSocket, "Request accepted");
            } // end while
        }
        // handle exception creating server and connecting clients
        catch (IOException ioException) {
            ioException.printStackTrace();
        }
    }
}



